package org.elasticsearch.plugins.security.filter;

import java.util.ArrayList;
import java.util.List;

import org.elasticsearch.common.bytes.BytesArray;
import org.elasticsearch.common.xcontent.XContentFactory;
import org.elasticsearch.common.xcontent.XContentType;
import org.junit.Test;

public class XContentParserTests {

	@Test
	public void testFieldAddDefault() throws Exception {
		org.junit.Assert
				.assertEquals(
						"{\"fields\":[\"_id\"],\"query\":{\"term\":{\"user\":\"kimchy\"}}}",
						new FieldResponseFilter(null).addFields(
								XContentFactory.xContent(XContentType.JSON)
										.createParser(
												new BytesArray(
														"{\"query\" : {\"term\" : { \"user\" : \"kimchy\" }}}"
																.getBytes())),
								null).string());
	}

	@Test
	public void testFieldAddNormal() throws Exception {

		final List<String> f = new ArrayList<String>();
		f.add("temp");
		f.add("myfield");

		org.junit.Assert
				.assertEquals(
						"{\"fields\":[\"temp\",\"myfield\"],\"query\":{\"term\":{\"user\":\"kimchy\"}}}",
						new FieldResponseFilter(null).addFields(
								XContentFactory.xContent(XContentType.JSON)
										.createParser(
												new BytesArray(
														"{\"query\" : {\"term\" : { \"user\" : \"kimchy\" }}}"
																.getBytes())),
								f).string());
	}

	@Test
	public void testFieldAddNoField() throws Exception {

		final List<String> f = new ArrayList<String>();

		org.junit.Assert
				.assertEquals(
						"{\"fields\":[\"_id\"],\"query\":{\"term\":{\"user\":\"kimchy\"}}}",
						new FieldResponseFilter(null).addFields(
								XContentFactory.xContent(XContentType.JSON)
										.createParser(
												new BytesArray(
														"{\"query\" : {\"term\" : { \"user\" : \"kimchy\" }}}"
																.getBytes())),
								f).string());
	}

}
